概要
sketchupでrubyやってみた。
練習問題やってみた。
練習問題
面だけで、球を作れ。
写真
サンプルコード
def tama
p1 = Geom::Point3d.new 0, 0, 0
p2 = Geom::Point3d.new 10, 10, 10
entities = Sketchup.active_model.entities
radius = p2.distance(p1)
dtheta = dphi = 360.0 / 16
-90.step(90, dtheta) do |theta|
0.step(360, dphi) do |phi|
group = entities.add_group
pts = []
x = radius * Math::cos(theta.degrees) * Math::cos(phi.degrees)
y = radius * Math::cos(theta.degrees) * Math::sin(phi.degrees)
z = radius * Math::sin(theta.degrees)
pts << (p1 + [x, y, z])
x = radius * Math::cos((theta + dtheta).degrees) * Math::cos(phi.degrees)
y = radius * Math::cos((theta + dtheta).degrees) * Math::sin(phi.degrees)
z = radius * Math::sin((theta + dtheta).degrees)
pts << (p1 + [x, y, z])
x = radius * Math::cos((theta + dtheta).degrees) * Math::cos((phi + dphi).degrees)
y = radius * Math::cos((theta + dtheta).degrees) * Math::sin((phi + dphi).degrees)
z = radius * Math::sin((theta + dtheta).degrees)
pts << (p1 + [x, y, z])
if theta > -90 && theta < 90
x = radius * Math::cos(theta.degrees) * Math::cos((phi + dphi).degrees)
y = radius * Math::cos(theta.degrees) * Math::sin((phi + dphi).degrees)
z = radius * Math::sin(theta.degrees)
pts << (p1 + [x, y, z])
end
begin
group.entities.add_face pts
rescue
end
end
end
end
以上。